Subject: FVWM: Yes! I did it! Almost everything is transparent!

From: Klaus Umbach <[email-masked]>
Date: Fri, 13 Dec 2002 05:58:01 +0100

Jipie!
Almost everything ist transparent now!
I'm totally proud about what I've done, so I have to show all of you my
screenshot: http://www.stud.uni-karlsruhe.de/~ugk8/screenshot.png

My X-Server hab needs more than 100MB in my RAM and it takes a really
awful hell lot of time to start fvwm2 now. (I even think about using
FvwmBanner for startup...) Well KDE3 starts a lot faster! :-)

But all this is it worth to have this Design!

It's of course not perfect, I still don't get the focused page in my
pager transparent and the focused menu entry. Anybody can help my?

Klaus
-- 
5) People say Linux is ugly. How does that make you feel?
Torvalds: They'll be the first against the wall when the revolution comes.
	  Let's see just how ugly they think it is when they have a few
	  bulletholes in them.

--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Klaus Umbach <[email-masked]>
Date: Sat, 14 Dec 2002 17:06:28 +0100

On Sat, Dec 14, 2002 at 04:50:22PM +0100, Martijn Bos wrote:
> Klaus,
> 
> I saw your transparent fvwm setup
> 
> I've never played with transparent windows , but this seems nice.
> 
> Would it be possible for you to sand a snippet of your  config so I can 
> learn?

Sure, you can download it at:
http://www.stud.uni-karlsruhe.de/~ugk8/fvwm-dev-transparent.tar.bz2

> Thanx in advance
> Martijn Bos
> ([email-masked])
> Klaus Umbach wrote:

-- 
Klaus Umbach <[email-masked]>
Pfinztalstr. 60
72667 Karlsruhe
Telefon: 0721-47639442

---

From: Olivier Chapuis <[email-masked]>
Date: Sun, 15 Dec 2002 17:15:54 +0100

> FvwmBanner for startup...) Well KDE3 starts a lot faster! :-)

* About memory: 

You use a 1512x864 root image. This implies that each colorset takes
~ 2Mb of memory. As you use 15 colorsets and you set your root background
with an Esetroot compatible program the memory usage of your config
is ~ 32Mb. A few suggestion:

  - Use a small (pretty) image to set your background.
  - When possible use the Transparent option and not the RootTransparent
    option (read carefully the FvwmTheme man page; Transparent + tint
    work only under certain special circonstance)
  - When possible do not use the "buffer" option (this is ok in general
    for a module that you rarely move & resize)
 
* About speed: 

Here one of your Colorset config definition:

Colorset 0 fg Black, NoShape, Plain, Transparent
Colorset 0 RootTransparent buffer
Colorset 0 tint white 40

Not first that "Plain" and "Transparent" are useless. I will write:

Colorset 0 fg Black, NoShape, RootTransparent buffer, tint white 40

This take some times because tinting a big image takes some
times (it is XRender which performs the tinting if you use a
recent XFree; with XFree-4.3 I hope that tinting will be mmxed).
With your config this is done 15 times.

Now, you do not specify a bg colour. This leads fvwm to compute
the average colour of your big root image. This is slow (more
slow than tinting). Again this is done 15 times. I think that
you can really speedup your startup time by specifying a bg
colour in all the definition of your colorsets:

Colorset 0 fg Black, bg grey, NoShape, RootTransparent buffer, tint white 40

If you really want an average bg (as this gives good sh/hi colours for
the 3d reliefs; but I do not think you want that, as almost every
things is flat on your screenshot), you can compute only one time the
average colour:

Colorset 0 fg Black, bg average, NoShape, RootTransparent buffer, tint white 40

Colorset 1 fg DarkGrey, bg $[bg.cs0], RootTransparent buffer, tint black 40
Colorset 2 fg Black, bg $[bg.cs0], RootTransparent buffer, tint white 40
..etc..

This is not perfect: if colorset 0 change, then the bg colour of the
colorset 1, 2, ...etc will be not updated. What we may do is to
cache the average colours.

I've noted that a few of your colorsets are identical (e.g., cs 0 and
2). Of course reducing the nbr of tinted RootTransparent cset will
speed up your startup and will reduce memory usage. What we should do
is to cache tinted images as we cache images.

> pager transparent and the focused menu entry. Anybody can help my?

Active menus entries do not use the Colorset image they just use the
bg Colorset (maybe one day the image will be used).  But you can use
the HilightBackOff menu style option.

For the pager the "focused" desk label does not use the colorset image
(just the colorset bg). But the focused page can be transparent.
 
Regards, Olivier

---

From: Olivier Chapuis <[email-masked]>
Date: Mon, 16 Dec 2002 17:15:26 +0100

On Mon, Dec 16, 2002 at 05:05:51AM +0100, Klaus Umbach wrote:
> Thank you, fvwm starts now in 10sec. :-) That's much better then 3
> minutes :-)
>

Great.
 
> But I still don't understand how to get the focused page transparent.
> 

*FvwmPager: HilightColorset * 12

should work. If this does not work can you check that the only
pager config read is in Acid6uru-fvwmpager.hook. I will remove
the lines:

*FvwmPager:             FocusColorSet   9
*FvwmPager:             Pixmap          none

and add at the beging of the file

DestroyModuleConfig FvwmPager*

After that for testing

Read Acid6uru-fvwmpager.hook

and restart the pager (or the Button if it is swallowed).

Olivier

---

From: Richard Curnow <[email-masked]>
Date: Mon, 16 Dec 2002 16:48:33 +0000

> screenshot: http://www.stud.uni-karlsruhe.de/~ugk8/screenshot.png

Which version of fvwm do you have this working on?

I've looked at your config files and tried to adapt bits of them to my
setup.  I'm trying both 2.5.4 and 2.5.5.

After a struggle I finally managed to get transparent menus like this:

Colorset 0 fg white, bg black, Shape, Plain
Colorset 0 Transparent
#Colorset 0 RootTransparent
Colorset 0 tint black 30
MenuStyle * MenuColorset 0

... but if I uncomment the 3rd Colorset line, I just get white text on
black menus with no transparency.

I can't get transparent title bars or borders at all though.  With title
bars I'm trying to do

Colorset 1 fg white, bg black, Shape, Plain
Colorset 1 Transparent
Colorset 1 tint #4060a0 30
TitleStyle	Inactive Colorset 1

but this has no effect and I just get a syntax error reported on the
console:
    unknown style Colorset : Colorset 1

Any clues?  The syntax for this stuff doesn't seem to be documented much
yet.

Thanks
Richard

-- 
Richard \\\ SuperH Core+Debug Architect /// .. At home ..
  P.    /// [email-masked]  ///  [email-masked]
Curnow  \\\ http://www.superh.com/    ///  www.rc0.org.uk
Speaking for myself, not on behalf of SuperH
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Mikhael Goikhman <[email-masked]>
Date: Mon, 16 Dec 2002 18:41:13 +0000

> MenuStyle * MenuColorset 0

You don't really need to split a colorset definition to 3 lines,
see enother message in this thread that explains speed problems.

> black menus with no transparency.

To use RootTransparent use should run "fvwm-root -r bg-image.png|xpm"
first. Or Esetroot.

>     unknown style Colorset : Colorset 1

You need 2.5.5 for this.

Only RootTransparent works in titles, not Transparent.

> Any clues?  The syntax for this stuff doesn't seem to be documented much

It is currently fully documented in the FvwmTheme man page that is
referred in the COLORSETS section of the fvwm man page, is not it?

Regards,
Mikhael.

---

From: Richard Curnow <[email-masked]>
Date: Tue, 17 Dec 2002 10:24:47 +0000

> see enother message in this thread that explains speed problems.

Yes, I saw that message.  I was doing it as I was for debugging, so that
I could selectively comment and uncomment things to find out what made
it work.  Now I've cracked it I'm moving to the single line approach.

> To use RootTransparent use should run "fvwm-root -r bg-image.png|xpm"

With fvwm-root -r this is now working fine for me.  I was using xsetbg
before.  The manual page says that ought to work, but I suspect I wasn't
using a new enough version.

> >     unknown style Colorset : Colorset 1

Ok - I've now switched to 2.5.5 and it's basically working as I expected
- thanks.

> referred in the COLORSETS section of the fvwm man page, is not it?

Yes, it's there as you say.  I was relying on just 'man fvwm' and not
finding much.

Thanks again.
Richard